import <iostream>;
using namespace std;

struct Vec {
  int x, y;

  Vec(int x, int y) {
    cout << "Vec Constructor: " << x << " " << y << endl;
    this->x = x;
    this->y = y;
  }
};

struct Basis {
  Vec v1{1,0}, v2{0,1};

  Basis() {}
  Basis(const Vec &v1, const Vec &v2): v1{v1}, v2{v2} {
    cout << "Basis Constructor" << endl;
  }
};


int main() {
  Vec v1{7,7};
  Vec v2{42,42};
  Basis b{v1, v2};
//  Basis b{{2,2},{3,3}};
  cout << b.v1.x << b.v1.y << b.v2.x << b.v2.y << endl;
  Basis c = b;
  cout << "Done with c" << endl;
  Basis d{c};
}
